#include "Window.h"
#include <cad.h>

const int QUANTITY_OF_PARTS = 3;
const int TOOLBAR_BUTTON_SIZE = 26;
const int TOOLBAR_HEIGHT = TOOLBAR_BUTTON_SIZE + 4;
const int COMBOBOX_ITEM_SIZE = 20;
const int LABELLAYOUTWIDTH = 80;
const int ERR_MSG_LEN = 256;

class CCADWindow : public CWindow  
{
	HANDLE hCAD;
	HINSTANCE hCADImporter;
	BOOL Drag;
	HCURSOR Cursor;
	int ScaleID;
	POINTS PredPoint;
	POINT offset;
	LONG DrwMode;	
	LONG CircleDrwMode;	
	int nIsInsideInsert;
	FPOINT ScaleRect;
	double fCoef, fAbsHeight, fAbsWidth;	
	bool bDoubleBuffered;
	bool bGetArcsAsCurves;
	bool bGetTextsAsCurves;
public:
//	int nIsInsideInsert;
	LPARAM lScalePoint;
	HINSTANCE HInst;
	double Scale;
	HWND hwndToolBar, hwndComboBox, hwndLayoutsLabel, hwndStatusBar;
	void GetLayers();
	CCADWindow(LPCTSTR, WNDPROC, HINSTANCE, HICON, HICON, LPCTSTR, HBRUSH, UINT);
	virtual ~CCADWindow();
	void DoCreateToolBar(HWND hwndParent, HINSTANCE hInst);
	void DoCreateComboBox(HINSTANCE hInst);
	void DoCreateStatusBar(HWND hwndParent, HINSTANCE hInst);
	void SplitStatusBar(int nParts= QUANTITY_OF_PARTS);
	//void SetTextToStatusBar(LPSTR str, int part = 0);
	bool SetCurrentLayout();
	void ReSize(WPARAM wParam,LPARAM lParam);
	void MouseMove(POINTS Point);
	void RecalculateExtents();
	void FitToWindow();

	void Load();
	void Draw(HWND Window, HDC DC);
	void BeginDrag(POINTS);
	void EndDrag(POINTS);
	void ChangeScale(LONG);
	void DrawingMode(LONG);
	void Circle(LONG);
	void ArcsAsCurves(LONG);
	void SwitchDblBuf();
	void TextsAsCurves();
	int WMPaint(HWND wnd, int Msg, int wParam, int lParam);
};
